class DefTests
  def simple_definition
    RBNF.def :abc do
      +(RBNF[?a]/?b/?c)
    end
    RBNF.abc
  end
  def recursive_definition
    RBNF.define :parens do
      RBNF[?(] + RBNF.parens.opt + ?)
    end
    RBNF.parens
  end
end

Lax.test(DefTests.new) {|assert|
  assert.calling(:recursive_definition).satisfies {|defn|
    %w{() (())}.all?  {|s| defn=~s} and
    %w{( ) (()}.none? {|s| defn=~s}
  }
  assert.calling(:simple_definition).satisfies {|defn|
    (0..5).all? do |n|
      %w{a b c}.permutation(n).all? do |p|
        s = p.join
        !!(s=~/[abc]*/) == defn.match(s)
      end
    end
  }

}

