class Repetition
  def a_binary_repetition
    RBNF[?A]*3+?G
  end

  def a_unary_repetition
    +(RBNF[?x]+?y+?z)
  end

  def binary_repetition_one_time
    RBNF[?q]*1
  end

  def binary_repetition_zero_times
    RBNF[?q]*0
  end
end

Lax.test(Repetition.new) {|that|
  that.calling(:a_binary_repetition).satisfies {|rep|
    rep =~ 'AAAG' and 
    [?g,'AG','AAAAAAG'].none?  {|s| rep=~s}
  }
  that.calling(:a_unary_repetition).satisfies {|rep|
    ['','xyz','xyzxyz'].all? {|s| rep.match s} and
    [?x,?y,?z,'zyx'].none? {|s| rep.match s}
  }
  that.calling(:binary_repetition_zero_times).satisfies {|rep|
    rep=~'' and !rep.match('q')
  }
}

