class StringTests
  def initialize
    @term = RBNF["string"]
  end

  def multiple_catenation
    (@term+'char'+'list').to_s
  end

  def multiple_alternation
    (@term/'char'/'list').to_s
  end

  def alternation_and_catenation
    (@term / 'opt' + @term / 'cat').to_s
  end

  def nested_repetition
    @term.rep.rep_n(3).to_s
  end

  def unary_repetition
    @term.rep.to_s
  end

  def binary_repetition
    @term.rep_n(3).to_s
  end

  def optation
    @term.opt.to_s
  end

  def a_definition
    RBNF.define(:symbol) do
      RBNF["string"]
    end.to_s
  end

  def terminal_string
    @term.to_s
  end

  def exception
    (@term/'integer' - 'float').to_s
  end

  def grouping
    (@term/@term).group.to_s
  end
  def implicit_grouping
    ((@term+@term)/@term).to_s
  end

end

Lax.test(StringTests.new) {|_|
  _.calling(:a_definition).returns 'symbol'
  _.calling(:terminal_string).returns '"string"'
  _.calling(:optation).returns '[ "string" ]'
  _.calling(:unary_repetition).returns '{ "string" }'
  _.calling(:binary_repetition).returns '3 * "string"'
  _.calling(:nested_repetition).returns '3 * { "string" }'
  _.calling(:alternation_and_catenation).returns '"string" | "opt" , "string" | "cat"'
  _.calling(:multiple_catenation).returns '"string" , "char" , "list"'
  _.calling(:multiple_alternation).returns '"string" | "char" | "list"'
  _.calling(:exception).returns '( "string" | "integer" - "float" )'
  _.calling(:grouping).returns '( "string" | "string" )'
  _.calling(:implicit_grouping).returns '( "string" , "string" ) | "string"'
}

